function[MatFin] = gameoflifenewimplementation(Mat) %Jeu de la vie

c = [[0, 0] ; [1, 0] ; [-1, 0] ; [0, 1]; [0, -1]; [1, 1]; [1, -1]; [-1, 1]; [-1, -1]]; % Voisinage à tester par décalage de la matrice

m = size(Mat,1); n = size(Mat,2);
MatFin = zeros(m,n);

MatTot = MatFin;
for i = 1 : size(c,1)
    MatTot = MatTot+circshift(Mat,c(i,:));
end

for i = 1 : m
    for j = 1 : n
        if Mat(i,j) == 0
            if MatTot(i,j) == 3
                MatFin(i,j) = 1;
            end
        elseif Mat(i,j) == 1
            if (MatTot(i,j) == 3) || (MatTot(i,j) == 4)
                MatFin(i,j) = 1;
            end
        end
    end
end